var muen = {};

muen.rndid = function(){
  var ret = [];
  d = new Date();
  ret.push( d.getFullYear() );
  ret.push( ( "00" + (d.getMonth()+1) ).slice(-2) );
  ret.push( ("00" + d.getDate()).slice(-2) );
  ret.push( ("00" + d.getHours()).slice(-2) );
  ret.push( ("00" + d.getMinutes()).slice(-2 ));
  ret.push( ("00" + d.getSeconds()).slice(-2) ); 
  ret.push( ("000" + d.getMilliseconds()).slice(-3) ); 
  ret.push( ("00000000" + Math.floor(Math.random()*100000000)).slice(-8) );
  return ret.join("");  
}

muen.now = function(format){
  var d = new Date();
  var ret = format;
  if (!(typeof (ret) == "string"))
  {
    //ret = "yyyy-mm-dd hh:nn:ss.zzz";
    ret = "yyyy-mm-dd hh:nn:ss";
  }
  return ret
    .replace(/yyyy/ig, d.getFullYear())
    .replace(/mm/ig, ("00" + (d.getMonth() + 1)).slice(-2))
    .replace(/dd/ig, ("00" + d.getDate()).slice(-2))
    .replace(/hh/ig, ("00" + d.getHours()).slice(-2))
    .replace(/nn/ig, ("00" + d.getMinutes()).slice(-2))
    .replace(/ss/ig, ("00" + d.getSeconds()).slice(-2))
    .replace(/zzz/ig, ("000" + d.getMilliseconds()).slice(-3))  
}

muen.run = function(f){
  if(typeof(f)=="function") {
    f();
  }
}

muen.url = function(url){
  var reg = {path: /([^\?#]+)(\??[^#]*)(#?.*)/};
  var ret = {};
  ret.href = url;
  var t = reg.path.exec(url);
  if (t.length > 3) {
    ret.path = t[1];
    ret.search = t[2];
    ret.hash = t[3];
  }
  return ret;
}

muen.getValue = function(str, startStr, endStr)
{
  var i = (startStr == null) ? 0 : str.indexOf(startStr);
  if (i == -1) return "";
  if (startStr)
  {
    str = str.slice(i + startStr.length);
  }
  if (endStr)
  {
    i = str.indexOf(endStr);
    if (i == -1) return "";
    return str.slice(0, i);
  }
  else
  {
    return str;
  }
}

muen.encoder = {};
muen.encoder.url = function (s) {
  var okAddressChars = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789_-";
  var hexchars = "0123456789ABCDEF";
  function utf8(wide) {
    var c;
    var s;
    var enc = "";
    var i = 0;
    while (i < wide.length) {
      c = wide.charCodeAt(i++);
      // handle UTF-16 surrogates
      if (c >= 0xDC00 && c < 0xE000)
        continue;
      if (c >= 0xD800 && c < 0xDC00) {
        if (i >= wide.length)
          continue;
        s = wide.charCodeAt(i++);
        if (s < 0xDC00 || c >= 0xDE00)
          continue;
        c = ((c - 0xD800) << 10) + (s - 0xDC00) + 0x10000;
      }
      // output value
      if (c < 0x80) {
        enc += String.fromCharCode(c);
      } else if (c < 0x800) {
        enc += String.fromCharCode(0xC0 + (c >> 6), 0x80 + (c & 0x3F));
      } else if (c < 0x10000) {
        enc += String.fromCharCode(0xE0 + (c >> 12), 0x80 + (c >> 6 & 0x3F), 0x80 + (c & 0x3F));
      } else {
        enc += String.fromCharCode(0xF0 + (c >> 18), 0x80 + (c >> 12 & 0x3F), 0x80 + (c >> 6 & 0x3F), 0x80 + (c & 0x3F));
      }
    }
    return enc;
  }
  function toHex(n) {
    return hexchars.charAt(n >> 4) + hexchars.charAt(n & 0xF);
  }
  
  var s = utf8(s);
  var c;
  var enc = "";
  for (var i = 0; i < s.length; i++) {
    if (okAddressChars.indexOf(s.charAt(i)) == -1) {
      enc += "%" + toHex(s.charCodeAt(i));
    } 
    else {
      enc += s.charAt(i);
    }
  }
  return enc;
};

muen.encoder.html = function (v) {
  return (""+v).replace(/&/g, "&amp;").replace(/</g, "&lt;").replace(/>/g, "&gt;").replace(/"/g, "&#34;").replace(/'/g, "&#39;");
};

module.exports = muen;